/// <reference types="react" />
import { SsProps } from "../useSs";
import WithChildren from "../WithChildren";
import WithHtmlAttributes from "../WithHtmlAttributes";
import BlockStyle from "./BlockStyle";
declare const ssProps: readonly ["bg", "radius"];
declare type IntrinsicElementNames = keyof JSX.IntrinsicElements;
interface Props extends Pick<SsProps, typeof ssProps[number]>, WithChildren, WithHtmlAttributes, BlockStyle {
    headingLevel?: 1 | 2 | 3 | 4 | 5 | 6;
    lineGap?: number;
    as?: IntrinsicElementNames;
}
export declare type TextProps = Props;
export declare const TextProvider: ({ children, ...props }: BlockStyle & WithChildren) => import("@emotion/react/jsx-runtime").JSX.Element;
declare const _default: import("react").ForwardRefExoticComponent<Props & import("react").RefAttributes<unknown>>;
export default _default;
