"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextProvider = void 0;
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var useTheme_1 = __importDefault(require("../useTheme"));
var react_2 = require("react");
var useSs_1 = __importDefault(require("../useSs"));
var core_1 = require("@capsizecss/core");
var isInlineContext_1 = __importDefault(require("./isInlineContext"));
var useStyleCss_1 = __importDefault(require("./useStyleCss"));
var getHtmlAttributes_1 = __importDefault(require("../getHtmlAttributes"));
var react_3 = require("react");
var ssProps = ["bg", "radius"];
var IsInlineProvider = isInlineContext_1.default.Provider;
var textContext = (0, react_2.createContext)({});
var Provider = textContext.Provider;
var TextProvider = function (_a) {
    var children = _a.children, props = __rest(_a, ["children"]);
    return (0, jsx_runtime_1.jsx)(Provider, __assign({ value: props }, { children: children }));
};
exports.TextProvider = TextProvider;
var Text = function (_a, ref) {
    var _b, _c, _d;
    var _e = _a.lineGap, lineGap = _e === void 0 ? 1 : _e, props = __rest(_a, ["lineGap"]);
    var _f = (0, useTheme_1.default)(), fontSize = _f.fontSize, defaultFont = _f.defaultFont, fonts = _f.fonts;
    var ss = (0, useSs_1.default)(props);
    var contextProps = (0, react_2.useContext)(textContext);
    props = __assign(__assign({}, contextProps), props);
    var headingLevel = props.headingLevel;
    var font = fonts[(_b = props.font) !== null && _b !== void 0 ? _b : defaultFont];
    var size = (_c = props.size) !== null && _c !== void 0 ? _c : "md";
    var styleCss = (0, useStyleCss_1.default)(props);
    if (!props.children)
        return null;
    return ((0, jsx_runtime_1.jsx)(IsInlineProvider, __assign({ value: true }, { children: (0, react_1.jsx)((_d = props.as) !== null && _d !== void 0 ? _d : (headingLevel ? "h".concat(headingLevel) : "p"), __assign(__assign({}, (0, getHtmlAttributes_1.default)(props)), { ref: ref, css: (0, react_1.css)(ss, styleCss, __assign({ fontFamily: font.name, textAlign: props.align }, (0, core_1.createStyleObject)({
                capHeight: fontSize(size).raw,
                lineGap: fontSize(size).raw * lineGap,
                fontMetrics: font.metrics,
            }))) }), props.children) })));
};
exports.default = (0, react_3.forwardRef)(Text);
