import { ComponentProps } from "react";
import { LinkProps } from "../Link";
import WithChildren from "../WithChildren";
import Text from "./Text";
declare const textPropsToForward: readonly ["color", "underline", "weight", "italic", "children"];
declare type TextPropsToForward = typeof textPropsToForward[number];
interface AsButtonProps {
    asButton: true;
    inline?: boolean;
    handleClick?: () => void;
}
interface AsLinkProps extends LinkProps {
    asButton?: false;
}
declare type Props = (AsButtonProps | AsLinkProps) & WithChildren & Pick<ComponentProps<typeof Text>, TextPropsToForward>;
declare const _default: import("react").ForwardRefExoticComponent<Props & import("react").RefAttributes<unknown>>;
export default _default;
